/**
 * Created by robin on 11/2/15.
 */

angular.module('luticate')
    .controller('UserEditController', ['$scope', 'luticateAuthUsers', 'data', '$q',
        function($scope, luticateAuthUsers, data, $q) {
            if (data != null) {
                $scope.user = data;
            }
            else {
                $scope.user = {
                    Username: "",
                    Email: "",
                    Firstname: "",
                    Lastname: ""
                };
            }
            $scope.userPassword = {
                value: "",
                confirm: ""
            };
            $scope.passwordValidation = {
                length: '$value.length >= 5 || $value.length == 0'
            };
            $scope.password2Validation = {
                same_passwords: 'userPassword.value==$value'
            };

            var promiseEditUser = {
                id: "promiseEditUser",
                loaderGroups: ["modal"]
            };
            var promiseAddUser = {
                id: "promiseAddUser",
                loaderGroups: ["modal"]
            };
            var promiseSetPassword = {
                id: "promiseSetPassword",
                loaderGroups: ["modal"]
            };

            $scope.submitForm = function()
            {
                if ($scope.user.Id != null) {
                    var defer = $q.defer();
                    luticateAuthUsers.edit({
                        user_id: $scope.user.Id,
                        email: $scope.user.Email,
                        firstname: $scope.user.Firstname,
                        lastname: $scope.user.Lastname
                    }, promiseEditUser)
                        .then(function(data)
                        {
                            if ($scope.userPassword.value != "") {
                                luticateAuthUsers.setPassword({
                                    user_id: $scope.user.Id,
                                    password: $scope.userPassword.value
                                }, promiseSetPassword)
                                    .then(defer.resolve, defer.reject);
                            }
                            else {
                                defer.resolve(data);
                            }
                        }, defer.reject);
                    return defer.promise;
                }
                else {
                    var user = {
                        username: $scope.user.Username,
                        email: $scope.user.Email,
                        firstname: $scope.user.Firstname,
                        lastname: $scope.user.Lastname,
                        password: $scope.userPassword.value
                    };
                    return luticateAuthUsers.add(user, promiseAddUser);
                }
            };
        }]);
